﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private pnlDrawing As B4XView
	Private canvas As B4XCanvas
	Private vx = 5dip, vy = 5dip As Int
	Private timer1 As Timer
	Private smiley As B4XBitmap
	Private size As Int = 40dip
	Private smileyRect, clearRect As B4XRect
	Private degrees As Float
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("Drawing")
	canvas.Initialize(pnlDrawing)
	timer1.Initialize("timer1", 10)
	timer1.Enabled = True
	smiley = xui.LoadBitmapResize(File.DirAssets, "smiley.png", size, size, True)
	smileyRect.Initialize(40dip, 120dip, 40dip + size, 120dip + size)
	clearRect.Initialize(0, 0, 0, 0)
End Sub

Sub pnlDrawing_Resize (Width As Double, Height As Double)
	canvas.Resize(Width, Height)
End Sub

#if B4A
Sub pnlDrawing_Touch (Action As Int, X As Float, Y As Float)
	Dim p As Panel = pnlDrawing
	If Action = p.ACTION_DOWN Then
		Click(X, Y)
	End If
End Sub
#else if B4J
Sub pnlDrawing_MouseClicked (EventData As MouseEvent)
	Click (EventData.X, EventData.Y)
End Sub
#end if

Private Sub Click(x As Float, y As Float)
	If X > smileyRect.Left And X < smileyRect.Right And _
		Y > smileyRect.Top And Y < smileyRect.Bottom Then
		vx = -vx
		vy = -vy
	End If
	canvas.DrawCircle(X, Y, 10dip, Rnd(0xff000000, 0xffffffff), True, 0)
	canvas.Invalidate
End Sub

Private Sub Timer1_Tick
	canvas.ClearRect(clearRect)
	UpdateRect(smileyRect, smileyRect.Left + vx, smileyRect.Top + vy, size)
	UpdateRect(clearRect, smileyRect.Left - 5dip, smileyRect.Top - 5dip, size + 10dip)
	If smileyRect.Right > canvas.TargetRect.Right Then
		vx = -Abs(vx)
	Else if smileyRect.Left < 0 Then
		vx = Abs(vx)
	End If
	If smileyRect.Bottom > canvas.TargetRect.Bottom Then
		vy = -Abs(vy)
	Else if smileyRect.Top < 0 Then 
		vy = Abs(vy)
	End If
	degrees = degrees + 1
	canvas.DrawBitmapRotated(smiley, smileyRect, degrees)
	canvas.Invalidate
End Sub

Private Sub UpdateRect(r As B4XRect, Left As Int, Top As Int, RectSize As Int)
	r.Left = Left
	r.Top = Top
	r.Right = r.Left + RectSize
	r.Bottom = r.Top + RectSize
End Sub





